import greenfoot.*; 

public class BlackBishop extends Black
{
    private boolean select = false;
    private int startx, starty, x, y, recflag, legflag, legalx, legaly, legalx2, legaly2, undox, undoy;

    public void act() //vertical shrink by a factor of 1/3
    {     
        GreenfootImage image = getImage();  
        image.scale(40, 40);
        setImage(image);

        selectpiece();
        undo();
    }    

    public void recordxy()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null && recflag == 0) {
            startx = mouse.getX();
            starty = mouse.getY();
            legalx = startx;
            legaly = starty;
            legalx2 = startx;
            legaly2 = starty;
            //System.out.println("Piece being clicked is at: " + startx + "," + starty);
            recflag++;
        }
    }

    public void selectpiece()
    {
        if (select == false) {
            if (Greenfoot.mouseClicked(this)) {
                select = true;
            }
        } else if (select == true) {
            deselectpiece();
            movepiece();
            //legalmoves();
            capture();
            //System.out.println("Selected!");
        }
    }

    public void deselectpiece() 
    { 
        if (Greenfoot.mouseClicked(this)) {
            select = false;
            getWorld().removeObjects(getWorld().getObjects(MoveDetect.class));
            //System.out.println("Deselected!");
        }
    }

    public void movepiece() //useless
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        legflag = 0;
        if (mouse != null) {
            recordxy();
            //System.out.println(startx + "," + starty);
            //System.out.println("Location of X mouse:" + mouse.getX());
            if((mouse.getX() - startx == mouse.getY() - starty) || (mouse.getX() - startx == starty - mouse.getY())) {
                setLocation(mouse.getX(), mouse.getY());
                //System.out.println(x + "," + y);
                if (isTouching(Black.class) == true) { //is piece touching another piece
                    setLocation(startx, starty);
                    select = false;
                }
                if (Greenfoot.mouseClicked(this)) {
                    undox = startx;
                    undoy = starty;
                    recflag = 0;
                } 
            }  
        }
    }

    public void capture()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        if ((isTouching(White.class) == true)) {
            Actor white;
            white = getOneObjectAtOffset(0, 0, White.class);
            if (Greenfoot.mouseClicked(white)) { 
                undox = startx;
                undoy = starty;
                World world;
                world = getWorld();
                world.removeObject(white);  
                recflag = 0;
                select = false;  
                setLocation(mouse.getX(), mouse.getY()); 
            }   
        }  
    }

    public void undo()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse != null)
        {
            if (mouse.getButton() == 3 && select == true)
            {
                setLocation(undox, undoy);
                select = false;
            }
        }
    }

    public void legalmoves()
    {
        if (legflag == 0 && select == true) {
            while (legalx < 7 && legaly < 7) {                  
                legalx = legalx + 1;   
                legaly = legaly + 1;
                if (legalx <= 7) {
                    getWorld().addObject(new MoveDetect(), legalx, legaly);
                }
            }   
            legalx = startx;
            legaly = starty;
            while (legalx > 0 && legaly > 0) {                  
                legalx = legalx - 1;   
                legaly = legaly - 1;
                if (legalx >= 0) {
                    getWorld().addObject(new MoveDetect(), legalx, legaly);
                }
            }
            legalx = startx;
            legaly = starty;             
        }
        if (legflag == 0 && select == true) {
            while (legalx2 != 0 && legaly2 != 7) {       
                legalx2 = legalx2 - 1;   
                legaly2 = legaly2 + 1;
                //System.out.println("startx:" + startx);
                //System.out.println("starty:" + starty);
                //System.out.println("x:" + legalx2);
                //System.out.println("y:" + legaly);
                if (legalx >= 0) {
                    getWorld().addObject(new MoveDetect(), legalx2, legaly2);
                }
            }
            legalx2 = startx;
            legaly2 = starty; 
            while (legalx2 != 7 && legaly2 != 0) {       
                legalx2 = legalx2 + 1;   
                legaly2 = legaly2 - 1;
                //System.out.println("startx:" + startx);
                //System.out.println("starty:" + starty);
                //System.out.println("x:" + legalx2);
                //System.out.println("y:" + legaly);
                if (legalx <= 7) {
                    getWorld().addObject(new MoveDetect(), legalx2, legaly2);
                }
            }
        }
    }
}