import greenfoot.*; 

public class BlackKing extends Black 
{
    private boolean select = false;
    private boolean hasmoved;
    private int startx, starty, x, y, recflag, undox, undoy;

    public void act() //vertical shrink by a factor of 1/3
    {     
        GreenfootImage image = getImage();  
        image.scale(40, 40);
        setImage(image);

        selectpiece();
        undo();
    }    

    public void recordxy()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null && recflag == 0) {
            startx = mouse.getX();
            starty = mouse.getY();
            //System.out.println("Piece being clicked is at: " + startx + "," + starty);
            recflag++;
        }
    }

    public void selectpiece()
    {
        if (select == false) {
            if (Greenfoot.mouseClicked(this)) {
                select = true;
            }
        } else if (select == true) {
            deselectpiece();
            movepiece();
            capture();
            //System.out.println("Selected!");
        }
    }

    public void deselectpiece() 
    { 
        if (Greenfoot.mouseClicked(this)) {
            select = false;
            //System.out.println("Deselected!");
        }
    }

    public void movepiece() //useless
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        if (mouse != null) {
            recordxy();
            //System.out.println(startx + "," + starty);
            //System.out.println("Location of X mouse:" + mouse.getX());
            if(((mouse.getX() == startx + 1) && (mouse.getY() == starty + 1)) || ((mouse.getX() == startx + 1) && (mouse.getY() == starty - 1)) || ((mouse.getX() == startx - 1) && (mouse.getY() == starty + 1))
            || ((mouse.getX() == startx - 1) && (mouse.getY() == starty - 1)) || (mouse.getX() == startx + 1) && (mouse.getY() == starty) || (mouse.getX() == startx - 1) && (mouse.getY() == starty) || (mouse.getX() == startx) && (mouse.getY() == starty + 1)
            || (mouse.getX() == startx) && (mouse.getY() == starty - 1) || (mouse.getX() == startx) && (mouse.getY() == starty)) {
                setLocation(mouse.getX(), mouse.getY());
                //System.out.println(x + "," + y);
                if (isTouching(Black.class) == true) { //is piece touching another piece
                    setLocation(startx, starty);
                }
                if (Greenfoot.mouseClicked(this)) {
                    hasmoved = true;
                    undox = startx;
                    undoy = starty;
                    recflag = 0;
                }
            } 
        }   
    }

    public void capture()
    {
        {
            MouseInfo mouse = Greenfoot.getMouseInfo(); 
            if ((isTouching(White.class) == true)) {
                Actor white;
                white = getOneObjectAtOffset(0, 0, White.class);
                if (Greenfoot.mouseClicked(this) || Greenfoot.mouseClicked(white)) {  
                    undox = startx;
                    undoy = starty;
                    World world;
                    world = getWorld();
                    world.removeObject(white);  
                    recflag = 0;
                    select = false;  
                    setLocation(mouse.getX(), mouse.getY()); 
                }   
            }  
        }     
    }
    
    public void undo()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse != null)
        {
            if (mouse.getButton() == 3 && select == true)
            {
                setLocation(undox, undoy);
                select = false;
            }
        }
    }
}

