import greenfoot.*; 

public class BlackPawn extends Black
{
    private boolean select = false;
    private boolean hasmoved = false;
    private int startx, starty, x, y, recflag, legflag, undox, undoy;

    public void act() //vertical shrink by a factor of 1/3
    {     
        GreenfootImage image = getImage();  
        image.scale(33, 33);
        setImage(image);

        selectpiece();
        undo();
    }    

    public void recordxy()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null && recflag == 0) {
            startx = mouse.getX();
            starty = mouse.getY();
            //System.out.println("Piece being clicked is at: " + startx + "," + starty);
            recflag++;
        }
    }

    public void selectpiece()
    {
        if (select == false) {
            if (Greenfoot.mouseClicked(this)) {
                select = true;
            }
        } else if (select == true) {
            deselectpiece();
            movepiece();
            capture();
            //legalmoves();
            //System.out.println("Selected!");
        }
    }

    public void deselectpiece() 
    { 
        if (Greenfoot.mouseClicked(this)) {
            select = false;
            getWorld().removeObjects(getWorld().getObjects(MoveDetect.class));
            //System.out.println("Deselected!");
        }
    }

    public void capture()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        if ((((mouse.getX() == startx + 1) && (mouse.getY() == starty + 1)) || ((mouse.getX() == startx - 1) && (mouse.getY() == starty + 1)))) {  
            setLocation(mouse.getX(), mouse.getY()); 
            if ((isTouching(Black.class) == true) && (Greenfoot.mouseClicked(this))) {
                setLocation(startx, starty);
                recflag = 0;                   
            }
            if ((isTouching(White.class) == true)) {
                Actor white;
                white = getOneObjectAtOffset(0, 0, White.class);
                if (Greenfoot.mouseClicked(white)) {
                    undox = startx;
                    undoy = starty;
                    World world;
                    world = getWorld();
                    world.removeObject(white);  
                    recflag = 0;
                    select = false;                  
                }   
            }     
        }  
    }

    public void movepiece() //useless
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        legflag = 0;
        if (mouse != null) {
            recordxy();
            //System.out.println(startx + "," + starty);
            //System.out.println("Location of X mouse:" + mouse.getX());
            if (starty == 1 && (((mouse.getX() == startx) && (mouse.getY() == starty + 1)) || ((mouse.getX() == startx) && (mouse.getY() == starty + 2))) 
            || (mouse.getX() == startx && mouse.getY() == starty)) {                       
                setLocation(mouse.getX(), mouse.getY()); 
                //System.out.println(mouse.getX() + "," + mouse.getY());
                if ((isTouching(White.class) == true)) {
                    Actor white;
                    white = getOneObjectAtOffset(0, 0, White.class);
                    if (isTouching(White.class) == true && Greenfoot.mouseClicked(white)) { //is piece touching another piece
                        setLocation(startx, starty);
                        select = false;
                    }
                }
                if ((isTouching(Black.class) == true)) {
                    setLocation(startx, starty);
                }
                if (Greenfoot.mouseClicked(this)) {
                    hasmoved = true;
                    undox = startx;
                    undoy = starty;
                    //System.out.println(undox + "," + undoy);
                    recflag = 0;
                }
            } else if ((mouse.getX() == startx) && (mouse.getY() == starty + 1)) {
                setLocation(mouse.getX(), mouse.getY());
                if ((isTouching(White.class) == true)) {
                    Actor white;
                    white = getOneObjectAtOffset(0, 0, White.class);
                    if (isTouching(White.class) == true && Greenfoot.mouseClicked(white)) { //is piece touching another piece
                        setLocation(startx, starty);
                        select = false;
                    }
                }
                if ((isTouching(Black.class) == true)) {
                    setLocation(startx, starty);
                }                
                if (Greenfoot.mouseClicked(this)) {
                    hasmoved = true;
                    undox = startx;
                    undoy = starty;
                    //System.out.println(undox + "," + undoy);
                    recflag = 0;                    
                }
            }  

        }
    }

    public void legalmoves()
    {
        if (legflag == 0 && select == true) {
            if (hasmoved == true) {
                getWorld().addObject(new MoveDetect(), startx, starty + 1);
                legflag = 1;
            }
            if (hasmoved == false) {
                getWorld().addObject(new MoveDetect(), startx, starty + 2);
                getWorld().addObject(new MoveDetect(), startx, starty + 1);
                legflag = 1;
            }
        }
    }

    public void undo()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse != null)
        {
            if (mouse.getButton() == 3 && select == true)
            {
                setLocation(undox, undoy);
                select = false;
            }
        }
    }

}
