import greenfoot.*; 

public class WhiteQueen extends White
{
    private boolean select = false;
    private int startx, starty, x, y, recflag, undox, undoy;

    public void act() //vertical shrink by a factor of 1/3
    {     
        GreenfootImage image = getImage();  
        image.scale(40, 40);
        setImage(image);

        selectpiece();
        undo();
    }    

    public void recordxy()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (mouse != null && recflag == 0) {
            startx = mouse.getX();
            starty = mouse.getY();
            //System.out.println("Piece being clicked is at: " + startx + "," + starty);
            recflag++;
        }
    }

    public void selectpiece()
    {
        if (select == false) {
            if (Greenfoot.mouseClicked(this)) {
                select = true;
            }
        } else if (select == true) {
            deselectpiece();
            movepiece();
            capture();
            //System.out.println("Selected!");
        }
    }

    public void deselectpiece() 
    { 
        if (Greenfoot.mouseClicked(this)) {
            select = false;           
            //System.out.println("Deselected!");
        }
    }

    public void movepiece() //useless
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        if (mouse != null) {
            recordxy();
            //System.out.println(startx + "," + starty);
            //System.out.println("Location of X mouse:" + mouse.getX());
            if(((mouse.getX() - startx == mouse.getY() - starty) || (mouse.getX() - startx == starty - mouse.getY())) || ((mouse.getX() == startx || mouse.getY() == starty))) {
                setLocation(mouse.getX(), mouse.getY());
                //System.out.println(x + "," + y);
                if (isTouching(White.class) == true) { //is piece touching another piece
                    setLocation(startx, starty);
                    select = false;
                }
                if (Greenfoot.mouseClicked(this)) {
                    undox = startx;
                    undoy = starty;
                    recflag = 0;
                } 
            }  
        }
    }

    public void capture()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo(); 
        if ((isTouching(Black.class) == true)) {
            Actor black;
            black = getOneObjectAtOffset(0, 0, Black.class);
            if (Greenfoot.mouseClicked(this)) {
                undox = startx;
                undoy = starty;
                World world;
                world = getWorld();
                world.removeObject(black);  
                recflag = 0;
                select = false;    
                setLocation(mouse.getX(), mouse.getY()); 
            }   
        }  
    }

    public void undo()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if(mouse != null)
        {
            if (mouse.getButton() == 3 && select == true)
            {
                setLocation(undox, undoy);
                select = false;
            }
        }
    }
}